# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['orwynn',
 'orwynn._di',
 'orwynn._di.collecting',
 'orwynn._di.init',
 'orwynn.apiversion',
 'orwynn.app',
 'orwynn.apprc',
 'orwynn.base.config',
 'orwynn.base.controller',
 'orwynn.base.database',
 'orwynn.base.error',
 'orwynn.base.exchandler',
 'orwynn.base.middleware',
 'orwynn.base.model',
 'orwynn.base.module',
 'orwynn.base.service',
 'orwynn.boot',
 'orwynn.context',
 'orwynn.http',
 'orwynn.http._context',
 'orwynn.http._controller',
 'orwynn.http._controller.endpoint',
 'orwynn.http._cors',
 'orwynn.http._exchandler',
 'orwynn.http._log',
 'orwynn.http._middleware',
 'orwynn.http._schema',
 'orwynn.indication',
 'orwynn.log',
 'orwynn.mapping',
 'orwynn.mongo',
 'orwynn.proxy',
 'orwynn.router',
 'orwynn.singleton',
 'orwynn.sql',
 'orwynn.testing',
 'orwynn.util',
 'orwynn.util.cls',
 'orwynn.util.crypto',
 'orwynn.util.dt',
 'orwynn.util.fmt',
 'orwynn.util.mp',
 'orwynn.util.parsing',
 'orwynn.util.rnd',
 'orwynn.util.uio',
 'orwynn.util.url',
 'orwynn.util.validation',
 'orwynn.util.yml',
 'orwynn.websocket',
 'orwynn.websocket._context',
 'orwynn.websocket._controller',
 'orwynn.websocket._exchandler',
 'orwynn.websocket._log',
 'orwynn.websocket._middleware',
 'orwynn.websocket._routing',
 'orwynn.worker']

package_data = \
{'': ['*']}

install_requires = \
['bcrypt==4.0.1',
 'colorama==0.4.6',
 'coverage==6.5.0',
 'dictdiffer==0.9.0',
 'fastapi==0.88.0',
 'httpx==0.23.1',
 'loguru==0.6.0',
 'psycopg2==2.9.5',
 'pyjwt==2.6.0',
 'pymongo==4.3.3',
 'pytest-asyncio==0.20.3',
 'pytest==7.2.0',
 'python-benedict==0.28.1',
 'python-dotenv==0.21.0',
 'pyyaml==6.0',
 'sqlalchemy==2.0.3',
 'uvicorn[standard]==0.20.0',
 'websockets==10.4']

setup_kwargs = {
    'name': 'orwynn',
    'version': '1.0.0a3',
    'description': 'Scalable web-framework with out-of-the-box architecture',
    'long_description': '# Orwynn',
    'author': 'ryzhovalex',
    'author_email': 'thed4rkof@gmail.com',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'None',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.11,<4.0',
}


setup(**setup_kwargs)
